xref: /openbmc/linux/scripts/link-vmlinux.sh (revision 2df8220c)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37is_enabled() {
38	grep -q "^$1=y" include/config/auto.conf
39}
40
41# Nice output in kbuild format
42# Will be supressed by "make -s"
43info()
44{
45	printf "  %-7s %s\n" "${1}" "${2}"
46}
47
48# Link of vmlinux
49# ${1} - output file
50# ${2}, ${3}, ... - optional extra .o files
51vmlinux_link()
52{
53	local output=${1}
54	local objs
55	local libs
56	local ld
57	local ldflags
58	local ldlibs
59
60	info LD ${output}
61
62	# skip output file argument
63	shift
64
65	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
66		# Use vmlinux.o instead of performing the slow LTO link again.
67		objs=vmlinux.o
68		libs=
69	else
70		objs="${KBUILD_VMLINUX_OBJS}"
71		libs="${KBUILD_VMLINUX_LIBS}"
72	fi
73
74	if is_enabled CONFIG_MODULES; then
75		objs="${objs} .vmlinux.export.o"
76	fi
77
78	objs="${objs} init/version-timestamp.o"
79
80	if [ "${SRCARCH}" = "um" ]; then
81		wl=-Wl,
82		ld="${CC}"
83		ldflags="${CFLAGS_vmlinux}"
84		ldlibs="-lutil -lrt -lpthread"
85	else
86		wl=
87		ld="${LD}"
88		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
89		ldlibs=
90	fi
91
92	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
93
94	# The kallsyms linking does not need debug symbols included.
95	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
96		ldflags="${ldflags} ${wl}--strip-debug"
97	fi
98
99	if is_enabled CONFIG_VMLINUX_MAP; then
100		ldflags="${ldflags} ${wl}-Map=${output}.map"
101	fi
102
103	${ld} ${ldflags} -o ${output}					\
104		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
105		${wl}--start-group ${libs} ${wl}--end-group		\
106		$@ ${ldlibs}
107}
108
109# generate .BTF typeinfo from DWARF debuginfo
110# ${1} - vmlinux image
111# ${2} - file to dump raw BTF data into
112gen_btf()
113{
114	local pahole_ver
115
116	if ! [ -x "$(command -v ${PAHOLE})" ]; then
117		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
118		return 1
119	fi
120
121	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
122	if [ "${pahole_ver}" -lt "116" ]; then
123		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
124		return 1
125	fi
126
127	vmlinux_link ${1}
128
129	info "BTF" ${2}
130	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
131
132	# Create ${2} which contains just .BTF section but no symbols. Add
133	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
134	# deletes all symbols including __start_BTF and __stop_BTF, which will
135	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
136	# objcopy warnings: "empty loadable segment detected at ..."
137	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
138		--strip-all ${1} ${2} 2>/dev/null
139	# Change e_type to ET_REL so that it can be used to link final vmlinux.
140	# Unlike GNU ld, lld does not allow an ET_EXEC input.
141	printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none
142}
143
144# Create ${2} .S file with all symbols from the ${1} object file
145kallsyms()
146{
147	local kallsymopt;
148
149	if is_enabled CONFIG_KALLSYMS_ALL; then
150		kallsymopt="${kallsymopt} --all-symbols"
151	fi
152
153	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
154		kallsymopt="${kallsymopt} --absolute-percpu"
155	fi
156
157	if is_enabled CONFIG_KALLSYMS_BASE_RELATIVE; then
158		kallsymopt="${kallsymopt} --base-relative"
159	fi
160
161	info KSYMS ${2}
162	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2}
163}
164
165# Perform one step in kallsyms generation, including temporary linking of
166# vmlinux.
167kallsyms_step()
168{
169	kallsymso_prev=${kallsymso}
170	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
171	kallsymso=${kallsyms_vmlinux}.o
172	kallsyms_S=${kallsyms_vmlinux}.S
173
174	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
175	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
176
177	info AS ${kallsyms_S}
178	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
179	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
180	      -c -o ${kallsymso} ${kallsyms_S}
181}
182
183# Create map file with all symbols from ${1}
184# See mksymap for additional details
185mksysmap()
186{
187	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
188}
189
190sorttable()
191{
192	${objtree}/scripts/sorttable ${1}
193}
194
195# Delete output files in case of error
196cleanup()
197{
198	rm -f .btf.*
199	rm -f System.map
200	rm -f vmlinux
201	rm -f vmlinux.map
202	rm -f .vmlinux.objs
203	rm -f .vmlinux.export.c
204}
205
206# Use "make V=1" to debug this script
207case "${KBUILD_VERBOSE}" in
208*1*)
209	set -x
210	;;
211esac
212
213if [ "$1" = "clean" ]; then
214	cleanup
215	exit 0
216fi
217
218#link vmlinux.o
219${MAKE} -f "${srctree}/scripts/Makefile.vmlinux_o"
220
221# Generate the list of in-tree objects in vmlinux
222#
223# This is used to retrieve symbol versions generated by genksyms.
224for f in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
225	case ${f} in
226	*libgcc.a)
227		# Some architectures do '$(CC) --print-libgcc-file-name' to
228		# borrow libgcc.a from the toolchain.
229		# There is no EXPORT_SYMBOL in external objects. Ignore this.
230		;;
231	*.a)
232		${AR} t ${f} ;;
233	*)
234		echo ${f} ;;
235	esac
236done > .vmlinux.objs
237
238# modpost vmlinux.o to check for section mismatches
239${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
240
241info MODINFO modules.builtin.modinfo
242${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
243info GEN modules.builtin
244# The second line aids cases where multiple modules share the same object.
245tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
246	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
247
248if is_enabled CONFIG_MODULES; then
249	${MAKE} -f "${srctree}/scripts/Makefile.vmlinux" .vmlinux.export.o
250fi
251
252${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
253
254btf_vmlinux_bin_o=""
255if is_enabled CONFIG_DEBUG_INFO_BTF; then
256	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
257	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
258		echo >&2 "Failed to generate BTF for vmlinux"
259		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
260		exit 1
261	fi
262fi
263
264kallsymso=""
265kallsymso_prev=""
266kallsyms_vmlinux=""
267if is_enabled CONFIG_KALLSYMS; then
268
269	# kallsyms support
270	# Generate section listing all symbols and add it into vmlinux
271	# It's a three step process:
272	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
273	#     but __kallsyms is empty.
274	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
275	#     the right size
276	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
277	#     the right size, but due to the added section, some
278	#     addresses have shifted.
279	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
280	# 3)  That link may have expanded the kernel image enough that
281	#     more linker branch stubs / trampolines had to be added, which
282	#     introduces new names, which further expands kallsyms. Do another
283	#     pass if that is the case. In theory it's possible this results
284	#     in even more stubs, but unlikely.
285	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
286	#     other bugs.
287	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
288	#
289	# a)  Verify that the System.map from vmlinux matches the map from
290	#     ${kallsymso}.
291
292	kallsyms_step 1
293	kallsyms_step 2
294
295	# step 3
296	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
297	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
298
299	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
300		kallsyms_step 3
301	fi
302fi
303
304vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
305
306# fill in BTF IDs
307if is_enabled CONFIG_DEBUG_INFO_BTF && is_enabled CONFIG_BPF; then
308	info BTFIDS vmlinux
309	${RESOLVE_BTFIDS} vmlinux
310fi
311
312info SYSMAP System.map
313mksysmap vmlinux System.map
314
315if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
316	info SORTTAB vmlinux
317	if ! sorttable vmlinux; then
318		echo >&2 Failed to sort kernel tables
319		exit 1
320	fi
321fi
322
323# step a (see comment above)
324if is_enabled CONFIG_KALLSYMS; then
325	mksysmap ${kallsyms_vmlinux} .tmp_System.map
326
327	if ! cmp -s System.map .tmp_System.map; then
328		echo >&2 Inconsistent kallsyms data
329		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
330		exit 1
331	fi
332fi
333
334# For fixdep
335echo "vmlinux: $0" > .vmlinux.d
336